################################################################################
# ################################################################################  
# #                                                                              #  
# # Viterbi HDL Code Generator                                                   #  
# # Copyright (C) 2004  Sheng Zhu                                                #  
# #                                                                              #  
# # This program is free software; you can redistribute it and/or                #  
# # modify it under the terms of the GNU General Public License                  #  
# # as published by the Free Software Foundation; either version 2               #  
# # of the License, or (at your option) any later version.                       #  
# #                                                                              #  
# # This program is distributed in the hope that it will be useful,              #  
# # but WITHOUT ANY WARRANTY; without even the implied warranty of               #  
# # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                #  
# # GNU General Public License for more details.                                 #  
# #                                                                              #  
# # You should have received a copy of the GNU General Public License            #  
# # along with this program; if not, write to the Free Software                  #  
# # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.  #  
# #                                                                              #  
# # If you have any problem, please email to me: mike@opencores.org              #  
# #                                                                              #  
# ################################################################################
################################################################################

require "perl/morphs.pl";
require "perl/utility.pl";
require "perl/glb_def.pl";
require "perl/filo.pl";
require "perl/pe0.pl";
require "perl/smu0.pl";
require "perl/trabacknew2.pl";
require "perl/virtual_mem.pl";
require "perl/vit2.pl";
require "perl/ctrl.pl";
require "perl/decoder0.pl";
require "perl/testbench0.pl";
require "perl/encode8.pl";
require "perl/vit2cpp.pl";

$LICENSE = 
'///////////////////////////////////////////////////////////////////
         //////                                    //////
///////////////////////////////////////////////////////////////////
///                                                             ///
/// This file is generated by Viterbi HDL Code Generator(VHCG)  ///
/// which is written by Sheng Zhu in Tsinghua University and     ///
/// distributed under GPL license.                              ///
///                                                             ///
/// If you have any advice, please email to mike@opencores.org  ///
///                                                             ///
///////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////


';

print "OK";

if($#ARGV>=1){
#	print @ARGV, "\n";
	%argv=@ARGV;
#	print $argv{'-POLYS'}, "\n";
}
else {die "no arguments input\nusage: command -POLYS \"91 121 101 91\" -B 4 -V 1 -RAW 10 -OSR 4 -TBL 32\n";}
para_initial();
butfly2(\$mod_name, \@ports_names);
delayT(\$mod_name, \@ports_names);
def_initial();
print "B=",$B,", $para_symbol_num, $W, $V, $U  @para_polys\n";
genfile("glb_def.v", \&glb_def);
genfile("ctrl.v", \&ctrl);
genfile("filo.v", \&filo);
genfile("pe0.v", \&pe0);
genfile("smu0.v", \&smu0);
genfile("trabacknew2.v", \&trabacknew2);
genfile("virtual_mem.v", \&virtual_mem);
genfile("vit2.v", \&vit2);
genfile("decoder0.v", \&decoder0);
genfile("testbench0.v", \&testbench0);
genfile("../c/encode8.cpp", \&encode8);
genfile("../c/vit2.cpp", \&vit2cpp);
print "1";		## tell outside it is ok
1
